//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ZAbstractDataset"
#pragma link "ZAbstractRODataset"
#pragma link "ZConnection"
#pragma link "ZDataset"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  iMode = 0;

  lstSEQ = new TStringList();
}
//---------------------------------------------------------------------------

__fastcall TForm1::~TForm1()
{
   if( lstSEQ ) delete lstSEQ;
}

void __fastcall TForm1::btnConnectClick(TObject *Sender)
{
  ZConnection1->Database = "D:\\GSB_DB\\TEST.FDB";
  ZConnection1->User     = "TEST";
  ZConnection1->Password = "1234";

  ZConnection1->Connect();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnInputClick(TObject *Sender)
{

  iMode = 0;

  TMemoryStream *mm = new TMemoryStream();

  try
  {
    ZQuery1->SQL->Clear();

    ZQuery1->SQL->Add( "INSERT INTO RICH_DATA ( TITLE, CMEMO ) " );
    ZQuery1->SQL->Add( "VALUES (:PTITLE, :PCMEMO)" );
    ZQuery1->ParamByName( "PTITLE" )->AsString = Edit1->Text;
    RichEdit1->Lines->SaveToStream( mm );                                       //Stream  ó ϸ   ġ  ŭ ̵մϴ.

    mm->Position = 0;

    ZQuery1->ParamByName( "PCMEMO" )->LoadFromStream( mm, ftBlob );


    ZQuery1->ExecSQL();
    ZConnection1->Commit();
  }
  __finally
  {
    delete mm;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSearchClick(TObject *Sender)
{
  iMode = 0;
  
  AnsiString asSQL = "SELECT * FROM RICH_DATA";

  ZQuery1->SQL->Clear();
  ZQuery1->SQL->Add( asSQL );
  ZQuery1->Open();

  ZQuery1->First();


  lstSEQ->Clear();
  ListBox1->Clear();

  int i=0;
  while( i<ZQuery1->RecordCount )
  {
    lstSEQ->Add( ZQuery1->FieldByName( "SEQ" )->AsString );
    ListBox1->Items->Add( ZQuery1->FieldByName( "TITLE" )->AsString );

    ZQuery1->Next();

    i++;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
  if( ListBox1->ItemIndex!=-1 )
  {
    iSEQ = StrToInt( lstSEQ->Strings[ ListBox1->ItemIndex ] );       //  ListBox1->Items->Strings[ ListBox1->ItemIndex ];

    AnsiString asSQL = "SELECT * FROM RICH_DATA WHERE SEQ = :ISEQ"; // + IntToStr(iSEQ);

    ZQuery1->SQL->Clear();
    ZQuery1->SQL->Add( asSQL );
    ZQuery1->ParamByName( "ISEQ" )->AsInteger = iSEQ;
    ZQuery1->Open();


    if( ZQuery1->RecordCount>0 )
    {
      ZQuery1->First();

      Edit1->Text =  ZQuery1->FieldByName( "TITLE" )->AsString;
      RichEdit1->Lines->LoadFromStream( ZQuery1->CreateBlobStream( ZQuery1->FieldByName( "CMEMO" ), bmRead ) );  //  ʹ  ֽŵ ڵ带 ؼ ϴϱ?  ϴ.

      iMode = 1;
    }
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnModifyClick(TObject *Sender)
{
  if( iMode!=1 )
  {
    btnInputClick( btnInput );   //Է
  }
  else
  {
    iMode = 0;

    TMemoryStream *mm = new TMemoryStream();

    try
    {
      ZQuery1->SQL->Clear();

      ZQuery1->SQL->Add( "UPDATE RICH_DATA SET CMEMO = :RICHMEMO WHERE SEQ = :ISEQ" );

      RichEdit1->Lines->SaveToStream( mm );                                     //Stream  ó ϸ   ġ  ŭ ̵մϴ.

      mm->Position = 0;

      ZQuery1->ParamByName( "RICHMEMO" )->LoadFromStream( mm, ftBlob );

      ZQuery1->ParamByName( "ISEQ" )->AsInteger = iSEQ;

      ZQuery1->ExecSQL();

      ZConnection1->Commit();
    }
    __finally
    {
      delete mm;
    }

  }


  if( ListBox1->ItemIndex!=-1 )    // Items->Strings[i])
  {
    AnsiString asSelect = ListBox1->Items->Strings[ ListBox1->ItemIndex ];

    AnsiString asSQL = "SELECT * FROM RICH_DATA WHERE TITLE=" + asSelect;

    ZQuery1->SQL->Clear();
    ZQuery1->SQL->Add( asSQL );
    ZQuery1->Open();


    if( ZQuery1->RecordCount>0 )
    {
      ZQuery1->First();
      RichEdit1->Lines->LoadFromStream( ZQuery1->CreateBlobStream( ZQuery1->FieldByName( "CMEMO" ), bmRead ) );  //  ʹ  ֽŵ ڵ带 ؼ ϴϱ?  ϴ.
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  RichEdit1->SelAttributes->Color = clRed;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDisconnectClick(TObject *Sender)
{
  ZConnection1->Disconnect();
        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
   RichEdit1->SelAttributes->Color = clBlue;
}
//---------------------------------------------------------------------------

